#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
#-------------------------------------------------------------------------
#    Name:  dbamon_trends.pl
#-------------------------------------------------------------------------
#
# Changes 
#
# 1.00 29Sep12 BB - Initial
#-------------------------------------------------------------------------
$version = "1.00"; 
$| = 1;
chop($P = `basename $0`); 
$P =~ s/\.pl$//g;

push(@INC,"/opt/dbamon/lib");

require "cgi_handlers.pl";
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

$maxrows = 250;
$stop_displaying = 0;

#---- Max these vars global
$in_categ = "";  

#---- PL and CSV Vars and FILES - Start - Should only happen 1 time
mkdir "/opt/dbamon/dat/dyn" if (! -e "/opt/dbamon/dat/dyn"); 
system("ln -s /opt/dbamon/dat/dyn /opt/dbamon/htm/dyn") if ! -e "/opt/dbamon/htm/dyn"; 

$pl_date = getdate(); 
$pl_date =~ s/\///g;
$pl_date =~ s/\://g;
$pl_date =~ s/\-/_/;
##$zdiag .= "new pl_date=($pl_date)\n"; 

#---- Read WWW_Font:

#---- Old
#chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
#if ($font =~ /%/)
#{
#  $font =~ s/%/ /g;
#  $font = "'$font'";
#}
#$zdiag .= "old font=($font)\n"; 

#---- New
$font                 = &readRC("WWW_Font:");
#$table_metrics_hourly = &readRC("Table_METRICS_HOURLY:");
#$table_detail_retain  = &readRC("Table_Detail_Retain_Days:");
#$table_detail_retain  = 30 if ! $table_detail_retain; 

##$zdiag .= "new font=($font)\n"; 

$font = "arial" if ! $font;

#---- Set connect string and hostname for URLs
if ($ENV{'HTTPS'} eq "on") { $http_prefix = "https://"; } 
else                       { $http_prefix = "http://"; } 
$http_host = $http_prefix . $ENV{'HTTP_HOST'};

$script_name = $ENV{'SCRIPT_NAME'};

#---- Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

use DBI;
require "cgi_handlers.pl";

#-----------------------------------------------------------------------------
sub trendInstance
#-----------------------------------------------------------------------------
{
  &msg("trendInstance - Starting"); 
  $s_time = time;
  $maxrows = 999999;
  $debug_tr = 0; 
  
  $recent_days = 7; 
  $hist_days   = 180; 

  my $html_out = ""; 

  if ($dbamon_repos eq "M")
  {
    $sql  = "select 
	category, 
	parm,
        count(*),
        avg(value)
      from 
	dbamon.metrics_detail
      where 
	instance = '$instance' 
        and dbamonmode = '$mode'
	and ts >= dateadd(dd,-$recent_days,getdate())
      group by
	category, 
	parm
      order by 1, 2
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }

  &msg("Querying DBAMON.METRICS_DETAIL data for instance_key=($instance) and mode=$mode for the last $recent_days days - sql=$sql");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  &msg("Query elapsed time: $elapsed seconds - Comparing recent samples to historical data...");

  $html_out .= "<p>
  <h4>DBAmon Metric Trend Comparison for Instance: $instance</h3>

  <table width=60% border=0 $style_normal bgcolor=linen><tr><td>For every Instance Metric 
  listed below, the average value over the last $recent_days days will be
  compared to the average value over the last $hist_days days. The recent value will then be
  divided by the historical value and the result will be displayed along with a comment (Hot, OK, Cold) in the
  right-most column. This will be useful in showing you where there have been significant recent
  recent changes when compared to historical averages.
  </table>

  <p>
  <table border=0 bgcolor=wheat $style_normal>
  
  <tr bgcolor=slateblue>
    <th><span $style_normal>Metric Category / Metric Parm 
    <th><span $style_normal>Chart URLs 
    <th><span $style_normal>Recent<br>Row Count<br>(Last<br> $recent_days Days) 
    <th><span $style_normal>Historical<br>Row Count<br>(Last<br> $hist_days Days) 
    <th><span $style_normal>Recent<br>Avg Value<br>(Last<br> $recent_days Days) 
    <th><span $style_normal>Historical<br>Avg Value<br>(Last<br> $hist_days Days) 
    <th colspan=2><span $style_normal> Recent Avg<br>/<br>Historical Avg
  \n";

  $selectcount = 0;

  $t_trend_high = 4; 
  $t_trend_low  = 0.5; 

  while (@Data = $sth->fetchrow_array)
  {
    $categ   = shift(@Data);  
    $parm    = shift(@Data);  
    $count   = shift(@Data);  
    $recent_avg  = shift(@Data);  

    $selectcount++; 

    &msg("DEBUG - Found categ=$categ parm=$parm") if $debug_tr; 
    ($hist_avg, $hist_count) = &selectHistory($categ, $parm); 
    &msg("  DONE - categ=$categ parm=$parm recent_avg=$recent_avg hist_avg=$hist_avg") if $debug_tr; 
    &msg(" ") if $debug_tr; 

    $recent_avg = sprintf("%.2f", $recent_avg); 
    $hist_avg   = sprintf("%.2f", $hist_avg); 

    $this_ratio = sprintf("%.2f", ($recent_avg / $hist_avg)) if $hist_avg > 0; 

    if    ($this_ratio > $t_trend_high) { $color_ratio = "pink";    $color_text = "Hot  - Recent Avg. of $recent_avg / Historical Avg. of $hist_avg = $this_ratio (&gt; Threshold of $t_trend_high)"; }
    elsif ($this_ratio < $t_trend_low ) { $color_ratio = "skyblue"; $color_text = "Cold - Recent Avg. of $recent_avg / Historical Avg. of $hist_avg = $this_ratio (&lt; Threshold of $t_trend_low)"; }
    else                                { $color_ratio = "lightgreen";    $color_text = "OK"; }

    #---- URLs
    #----   http://localhost/cgi-bin/dbamon_metrics.pl?test,GRAW,localhost_MSSQL2,PERF_SQL_BUFFERCACHEHITRATIO,.,30,
    #----   http://localhost//cgi-bin/dbamon_metrics.pl?test,MDAILY,localhost_MSSQL2,DRIVE_PCT_FULL,C
    $urls = "
<a href='/cgi-bin/dbamon_metrics.pl?$mode,GRAW,$instance,$categ,$parm,30,'><b>Chart L30D</b></a> | 
<a href='/cgi-bin/dbamon_metrics.pl?$mode,MDAILY,$instance,$categ,$parm'><b>Hist. Charts</b></a>
    "; 

    ##  <td $style_normal> <b> <a href='$http_host/${script_name}?$mode,$verb,$instance,$categ,$parm'>$categ / $parm</a>  </b>

    $bg = &bgRow;
    $html_out .= "<tr $bg>
      <td nowrap $style_normal> <b>$categ / $parm</b>
      <td nowrap $style_normal> &nbsp; $urls &nbsp;
      <td nowrap $style_normal align=right>  $count  
      <td nowrap $style_normal align=right>  $hist_count  
      <td nowrap $style_normal align=right> <b> $recent_avg  </b>
      <td nowrap $style_normal align=right> <b> $hist_avg    </b>
      <td nowrap $style_normal align=right bgcolor=$color_ratio> &nbsp; <b> $this_ratio  </b> &nbsp;
      <td nowrap $style_normal align=left  bgcolor=$color_ratio> &nbsp; <b> $color_text  </b>
    " if ! $stop_displaying; 

    if (++$selectcount > $maxrows && ! $stop_displaying) 
    { 
      print "<tr bgcolor=pink><td colspan=15><b><font size=2>MaxRows threshold of $maxrows exceeded - Rows will be processed for files, but no more will be displayed\n";
      print "</table>\n";
      $stop_displaying = 1; 
    }
  }

  &msg("Done comparing");

  #---- Display entire table
  print "$html_out 
  </table>
  ";

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b>No event history data found for instance: $instance\n";
  }
  print "</table>\n";

  $e_time = time - $s_time;

  &msg("trendInstance - Done - selectcount=$selectcount e_time=$e_time");
}

#-----------------------------------------------------------------------------
sub selectHistory
#-----------------------------------------------------------------------------
{
  my $in_categ = $_[0];
  my $in_parm  = $_[1];
  
  my $debug_sh = 0; 

  &msg("    selectHistory - Starting - in_categ=$in_categ in_parm=$in_parm") if $debug_sh; 

  if ($dbamon_repos eq "M")
  {
    $sql2 = "select 
	avg(avg),
        count(*)
      from 
	dbamon.dbamon.metrics_daily
      where 
	instance       = '$instance' 
        and dbamonmode = '$mode'
        and category   = '$in_categ'
        and parm       = '$in_parm'
        and ts > dateadd(dd, -$hist_days, getdate())
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }

  $sth2 = $dbh->prepare($sql2) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &error('Failed_on_DB_execute_in_chgEnt');

  my $avg_avg = -1; 
  my $hist_count = -1; 

  my $selectcount = 0; 

  while (@Data = $sth2->fetchrow_array)
  {
    $avg_avg  = shift(@Data); 
    $hist_count  = shift(@Data); 
    $selectcount++; 
  }

  &msg("      Result - avg_avg=$avg_avg selectcount=$selectcount") if $debug_sh;

  &msg("    selectHistory - Done - Returning $avg_avg") if $debug_sh; 
  return ($avg_avg, $hist_count); 
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   print "Signal=$Signal\n";
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

&get_request;

@words = split(/,/,$ARGV[0]);
$mode     = $words[0];
$verb     = $words[1];
$instance = $words[2];
$in_categ = $words[3];
$in_parm  = $words[4];
$in_days  = $words[5]; 
$in_label = $words[6]; 

&header("Metrics Trend Analysis") unless $ENV{'DBAMON_NOWEB'}; 

&msg("Starting - version=$version - mode=($mode) verb=($verb) instance=($instance) in_categ=($in_categ) in_parm=($in_parm) in_days=($in_days) in_label=($in_label) - maxrows=$maxrows - http_host=($http_host) script_name=$script_name");

&connectDB;

#---- Call according to parms passed 
if (! $mode) 
{ 
  &error("MODE (1st parm) Must be specified");
}

if ($verb eq "TREND_M") 
{
  &trendInstance; 
}
else 
{ 
  &error("Unknown verb=($verb) passed");
}

#---- Terminate
&msg("Done");
exit 0;
