# -----------------------------------------------------------------------------
sub oraTSFull
{
  ($thishost) = @_;
  #
  # Get Instance online data
  #

  if ($up[$thishost] ne "Y")
  {
    logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up_logswitchwait eq "ARCHIVE_LOG")
  {
    &logit("(Instance Hung - There is no point in doing this)",$thishost);
    return;
  }

  if ($up[$thishost] eq "D")
  {
    &logit("(No software download)",$thishost);
    return;
  }

  if ($t_diskcrit[$thishost] eq "" && $t_diskwarn[$thishost] eq "")
  {
    logit("T_TS_Full: Not Specified",$thishost);
    &history_dummy($thishost);
    return;
  }

  #---- Enhancement level 3.91:
  if ($ops[$thishost] eq "YES" && $inst_num[$thishost] > 1)
  {
    logit("This is instance  $inst_num[$thishost] in a RAC/OPS cluster - Not checking tablespaces (DBAmon only checks instance #1)",$thishost);
    &history_dummy($thishost);
    return;
  }

  if ($asmflag[$thishost])
  {
    &logit("ASM Instance - Running oraDGFull",$thishost);
    &oraDGFull($thishost)
    &logit("ASM Instance - Back from oraDGFull",$thishost);
    return;
  }

  if ($g_history_to_file eq "Y") 
  {
    # Check to see if  we need to create history data
    chop($filedate = `date +%C%y.%m.%d`);
    chop($filetime = `date +%H:%M:%S`);
    $hist_flag = 0;
    if (system("grep '$titleraw[$thishost]' $hstdir/dbspaces/$filedate > /dev/null 2>&1") != 0)
    {
      &logit("Setting flag to create tblspace history data",$thishost);
      system("rm $tmpflt > /dev/null 2>&1");
      $hist_flag = 1;
    }
  }

  $total_size = 0;
  $total_free = 0;
  $total_used = 0;
  $total_chks = 0;
  $total_need = 0;

  system("rm -fr $tmpfl3");

  if ($ts_command[$thishost] ne "")
  {
    # invoke with ts_fill {Twarn} {Tcrit} {Tfree}
    $parm = "$probe[$thishost] ts_full $t_diskwarn[$thishost] $t_diskcrit[$thishost] $t_freespace[$thishost] \"$ts_command[$thishost]\"";
  }
  else
  {
    # invoke with ts_fill {Twarn} {Tcrit} {Tfree}
    $parm = "$probe[$thishost] ts_full $t_diskwarn[$thishost] $t_diskcrit[$thishost] $t_freespace[$thishost]";
  }

  ##print "parm=$parm \n";
  &remsh($parm,$tmpfl3,$thishost);
  ##system("cat $tmpfl3");

  #See if auto-inhibit occured
  if ($up[$thishost] eq "I")
  {
    logit("(Auto-Inhibited)",$thishost);
    return;
  }

  logDetails($thishost,"<h3>Oracle Tablespaces</h3>");
  logDetails($thishost,"<table border=1 bgcolor=antiquewhite>");
  logDetails($thishost,"<tr bgcolor=slate><th>Tablespace<th>Size (MB)<th>Used (MB)<th>Free (MB)<th>Percent Full<th>Status:<br>W=Warning<br>C=Critical</tr><th>TS Type<th>mB Needed<br>To Get Below<br>Warning<br>Threshold");

  $tsokflag = 1;
  $fstotalsize = 0;

  open(TMPFL3, "$tmpfl3") || &error_msg("Can't open input $tmpfl3 - $!");
  while (<TMPFL3>)
  {
    &parse;

    if ($F2 eq "TOT_FSSIZE_GB:") 
    {
      $fstotalsize = $F3;
      ##print "fstotalsize=$fstotalsize\n";
    }

    if ($F1 eq "COALESCING:" && $runmon[$thishost] ne "B") 
    {
      &event("U",$thishost,"Tablespace $F2 Was Coalesced","TSCoal","DBA626",$tmpfl3);
    }

    if ($F1 eq "RBSSHRINKING:" && $runmon[$thishost] ne "B") 
    {
      &event("W",$thishost,"RBS Segments In Tablespace $F2 Were Shrunk ","TSShrunk","DBA627W",$tmpfl3);
    }

    if ($F1 eq "DBAMON_TS_ADD" && $runmon[$thishost] ne "B") 
    {
      $rc = $F2;
      $ts = $F3;
      $pc = $F4;
      $ad = $F5;
      if ($F2 ne "0") 
      {
        &event("C",$thishost,"Add Datafile Command Failed - rc=$F2 cmd=$ts_command[$thishost] ts=$ts pc=$pc ad=$ad","TSAddNG","DBA623C",$tmpfl3);
      }
      else  # Create user event
      {
        &event("U",$thishost,"Added Datafile to TS: $ts - Was: ${pc}% Full - Added: $ad MB","TSAddOK","DBA624U",$tmpfl3);
      }
    }
    if ($F1 eq "DBAMON_TS_SIZE") 
    {
      $ts    = $F2 ;
      $size  = $F3 ;
      $used  = $F4 ;
      $free  = $F5 ;
      $pct   = $F6 ;
      $status= $F7 ;

      if ($status eq "OK")
      {
        $needed= "" ;
        $type  = $F8 ;
      }
      else
      {
        $needed= $F8 ;
        $type  = $F9 ;
      }

      $mbfree = int($free);
      $mbsize = int($size);
      $mbused = int($used);

      $color = "lime";
      if ($status eq "C") { $color = "red" }
      if ($status eq "W") { $color = "yellow" }
      logDetails($thishost,"<tr bgcolor=$color>
        <td><b>$f_s $ts
        <td align=right><b>$f_s $size
        <td align=right><b>$f_s $used
        <td align=right><b>$f_s $free
        <td align=right><b>$f_s $pct
        <td><b>$f_s $status
        <td><b>$f_s $type
        <td align=right><b>$f_s $needed");

      if ($status ne "OK" && $runmon[$thishost] ne "B") 
      {
        if ($status eq "C") 
        {
	  ##system("cat " tmpfl3)
          &event("C",$thishost,"Oracle TS: $ts - ${pct}% Full - Critical ($mbfree MB Free - Threshold: ${t_diskcrit[$thishost]}%)","TS","DBA621C",$tmpfl3);
          $tsokflag = 0;   
        }
        if ($status eq "W") 
        {
	  ##system("cat " tmpfl3)
          &event("W",$thishost,"Oracle TS: $ts - ${pct}% Full - Warning ($mbfree MB Free - Threshold: ${t_diskwarn[$thishost]}%)","TS","DBA622W",$tmpfl3);
          $tsokflag = 0;   
        }
      }

      $total_size += $mbsize;
      $total_free += $mbfree;
      $total_used += $mbused;
      $total_need += $needed;

      #
      # Create hist data line
      #

      if ($g_history_to_file eq "Y") 
      {
	if ($hist_flag)
	{
	  system("echo '$filedate $filetime $title[$thishost] $ts . $mbsize $mbused $dbms[$thishost] $fstotalsize' >> $tmpflt");
	}
      }

      #---- Create history data in repository
      &histCreate("oraTSFull()",$thishost,"SPC",$ts,$mbsize,$mbused,$fstotalsize);
      $gbtot_oracle += ($mbsize / 1000);
    }
  }
  close(TMPFL3);

  if ($total_size == 0)
  {
    &event("W",$thishost,"Oracle Error encountered while checking tablespaces","TSErr","DBA625W",$tmpfl3);
    &downloadFlagOff($thishost);
    return 1;
  }

  &logDetails($thishost,"
    <tr bgcolor=slate>
      <td><b>Totals:</b>
      <td align=right><b>$f_s $total_size
      <td align=right><b>$f_s $total_used
      <td align=right><b>$f_s $total_free
      <td>
      <td>
      <td>
      <td align=right><b>$f_s $total_need
  ");
  &logDetails($thishost,"</table><hr>");

  $system_size[$thishost] = int($total_size / 1000);
  $system_used[$thishost] = int($total_used / 1000);
  $grand_total_size += $total_size / 1000;

  #
  # Write temp dbspace hist file to this dates file
  #

  if ($g_history_to_file eq "Y") 
  {
    if ($hist_flag)
    {
      &logit("Creating tablespace history data in ${hstdir}/dbspaces/${filedate}",$thishost);
      system("sort $tmpflt >> ${hstdir}/dbspaces/${filedate} ");

      ##print "TEST-----sort $tmpflt >> $hstdir/dbspaces/$filedate\n";
      ##system("ll $hstdir/dbspaces/$filedate");
      ##system("cat $tmpflt");
    }
  }

  if ($tsokflag)
  {
    logit("OK",$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
